package com.ywt.config.jpa;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.autoconfigure.orm.jpa.HibernateProperties;
import org.springframework.boot.autoconfigure.orm.jpa.HibernateSettings;
import org.springframework.boot.autoconfigure.orm.jpa.JpaProperties;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.orm.jpa.EntityManagerFactoryBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.orm.jpa.JpaTransactionManager;
import org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import javax.persistence.EntityManager;
import javax.sql.DataSource;
import java.util.Map;

/**
 * ywt_center数据库配置
 * @author dyh
 */
@Configuration
@EnableTransactionManagement
@EnableJpaRepositories(
        entityManagerFactoryRef = "entityManagerFactoryBase",
        transactionManagerRef = "transactionManagerBase",
        basePackages = {"com.ywt.mg.domain.entity.center"}
)

public class YwtCenterConfig {
    @Autowired
    @Qualifier("ywtCenterDataSource")
    private DataSource ywtCenterDataSource;

    @Bean(name = "entityManagerBase")
    public EntityManager entityManager(EntityManagerFactoryBuilder builder,@Qualifier("ywtCenterJpaProperties") JpaProperties jpaProperties) {
        return entityManagerFactory(builder,jpaProperties).getObject().createEntityManager();
    }

    @Bean(name = "entityManagerFactoryBase")
    public LocalContainerEntityManagerFactoryBean entityManagerFactory (EntityManagerFactoryBuilder builder,  @Qualifier("ywtCenterJpaProperties") JpaProperties jpaProperties) {
        return builder
                .dataSource(ywtCenterDataSource)
                .properties(jpaProperties.getProperties())
                .properties(new HibernateProperties()
                        .determineHibernateProperties(
                                jpaProperties.getProperties(), new HibernateSettings()))
                .packages("com.ywt.mg.domain.entity.center") //设置实体类所在位置
                .persistenceUnit("askcenterPersistenceUnit")
                .build();
    }

    @Autowired
    private JpaProperties jpaProperties;

    @Bean(name = "ywtCenterJpaProperties")
    @ConfigurationProperties(prefix = "spring.jpa.ywtcenter")
    public JpaProperties jpaProperties() {
        return new JpaProperties();
    }

    @Bean(name = "transactionManagerBase")
    public PlatformTransactionManager transactionManager(EntityManagerFactoryBuilder builder) {
        return new JpaTransactionManager(entityManagerFactory(builder, jpaProperties()).getObject());
    }
}
